<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

/*
 * @Package     CodeIgniter 2.1.3
 * @author      Carles Figuerola <cfiguerola0@uoc.edu> 
 * @copyright   Copyright (c) 2014, Carles Figuerola
 * @category    Controllers <02/04/2014>
 */

class Clogin extends CI_Controller {

    // Càrrega de models
    public function __construct() {
        parent::__construct();
        $this->lang->load('general', 'catalan');        
        $this->load->model('mlogin');
        $this->load->model('mcaptcha');        
    }

    // mètode consulta password per un id donat
    public function getPass() {
        
        $id = $this->input->get('id_user');

        $query = $this->mlogin->getPass($id);
        header('Content-Type: application/json',true);
        $json = json_encode($query);
        echo $json;
        
    }    

    // mètode consulta password per un id donat
    public function getMail() {
        
        $email = $this->input->get('email_user');

        $query = $this->mlogin->getMail($email);
        header('Content-Type: application/json',true);
        $json = json_encode($query);
        echo $json;
        
    }

    // mètode per canviar la contrasenya
    public function chgPass() {

        $id = $this->session->userdata('id_notificadorweb');
        $newpass = $this->input->post('PASSWORD');   
        $nom = $this->input->post('NOMEMISOR');   
        
        $time = now();
        $fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));     
        $date = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);


        $data = array(
            'PASSWORD' => $newpass 
            );


        $result = $this->mlogin->chgPass($id,$data);



        if ($result!=NULL){

            $data['title'] = 'Targeta Groga';
            $data['main_content'] = 'vActualitzacioSuccess';
            $data['nomemisor'] = $nom;
            $data['date'] = $date;

            $this->load->view('vtemplate', $data);             

        } else {
            return false;
        }

    }

    // mètode d'accés per usuaris registrats
    public function access() {

        if (!isset($_POST['EMAILACCESS'])) {
            $data = array(
                'title' => $this->lang->line('titol'), 
                'main_content' => 'vLogin'
                );

                $this->load->view('vtemplate', $data);

        } else {
            $result = $this->mlogin->getLogin($_POST['EMAILACCESS'], $_POST['PASSWORDACCESS']);


                if ($result!=NULL){ 

                    foreach ($result as $key) {
                        $id_notificadorweb = $key->ID_NOTIFICADORWEB;
                        $nom_notificadorweb = $key->NOMEMISOR;
                    }

                    $sesion_data = array(
                        'id_notificadorweb' => $id_notificadorweb,
                        'nom_notificadorweb' => $nom_notificadorweb
                    );                    

                    $this->session->set_userdata($sesion_data);

                    $data['id_notificadorweb'] = $this->session->userdata['id_notificadorweb'];
                    $data['nom_notificadorweb'] = $this->session->userdata['nom_notificadorweb'];
                    $data['main_content'] = 'vIndex';
                    $data['title'] = $this->lang->line('titol');

                    $this->load->view('vtemplate', $data);
                } else {

                    $data['title'] = $this->lang->line('titol');
                    $data['main_content'] = 'vLogin';
                    $data['email'] = $_POST['EMAILACCESS'];
                    $data['error']="Les dades introduïdes no són correctes, torna a intentar-ho.";
                    $this->load->view('vtemplate', $data);
                }
            }

    }


    // mètode per registre d'usuaris
    public function registre_user() {

        if($this->session->userdata('id_notificadorweb')){
            
            $id_notificadorweb = $this->session->userdata('id_notificadorweb');

            $data = array (
                'ID_NOTIFICADORWEB' => $id_notificadorweb,        
                );

            $result = $this->mlogin->getDadesAccess($data);

            if($result!=NULL){

                $data['title'] = 'Targeta Groga';
                $data['main_content'] = 'vRegistre';
                $data['dades'] = $this->mlogin->getDadesAccess($data);

                $this->load->view('vtemplate', $data);                    

            } 

        } else {

            $this->form_validation->set_rules('ID_PROFESSIO','Professio','');
            $this->form_validation->set_rules('ALTRA_PROFESSIO','Altra professio','');
            $this->form_validation->set_rules('NOMEMISOR','Nombre','');
            $this->form_validation->set_rules('COGNOMSEMISOR','Cognoms','');
            $this->form_validation->set_rules('ADRECA','Adreça','');
            $this->form_validation->set_rules('POBLACIO','Poblacio','');
            $this->form_validation->set_rules('ID_PROVINCIA','Provincia','');
            $this->form_validation->set_rules('CENTRETREBALL','Centre treball','');
            $this->form_validation->set_rules('TELEFON','','');
            $this->form_validation->set_rules('EMAIL','Email','');
            $this->form_validation->set_rules('EMAIL2','email 2','');

            $this->form_validation->set_rules('captcha','Captcha','callback_captcha_check');

            $this->form_validation->set_error_delimiters('<span class="error font-red ">', '</span>');


            if ($this->form_validation->run('captcha') == false){ 

                $captcha = array(
                    'word' => '',
                    'img_path' => './captcha/',
                    'img_url' => base_url().'captcha/',
                    'font_path' => './fonts/DroidSans.ttf',
                    'img_width' => 150,
                    'img_height' => 30,
                    'expiration' => 3600
                    );


            /* 
                Paràmetres cambiats a captcha_helper.php (per -> size i color de la font)   
                
                $font_size  = 16;
                $text_color = imagecolorallocate ($im, 204, 153, 153);
            */

                $cap = create_captcha($captcha);


                $captcha_info = array(
                    'captcha_time' => $cap['time'],
                    'ip_address' => $this->input->ip_address(),
                    'word' => $cap['word']
                    );

                $this->mcaptcha->insertCaptcha($captcha_info);

                $page = array(
                    'title' => $this->lang->line('titol'),
                    'main_content' => 'vRegistre',
                    'cap' => $cap
                    );

                $this->load->view('vtemplate',$page);

            } else {

        $altraprofessio = '';
        $professio = $this->input->post('ID_PROFESSIO');

        if ($professio == 6){
            $altraprofessio = $this->input->post('ALTRA_PROFESSIO');
        }

        $nomemisor = $this->input->post('NOMEMISOR');
        $cognomsemisor = $this->input->post('COGNOMSEMISOR');
        $adreca = $this->input->post('ADRECA');
        $poblacio = $this->input->post('POBLACIO');
        $provincia = intval($this->input->post('ID_PROVINCIA'));
        $centretreball = $this->input->post('CENTRETREBALL');
        $telefon = $this->input->post('TELEFON');
        $email = $this->input->post('EMAIL');
        $pass = $this->input->post('PASSWORD');        
        
        // INSERT taula DT_NOTIFICADORWEB
        $data = array(

            'ID_PROFESSIO' => intval($professio),
            'ALTRA_PROFESSIO' => $altraprofessio,
            'NOMEMISOR' => $nomemisor,
            'COGNOMSEMISOR' => $cognomsemisor,
            'ADRECA' => $adreca,
            'POBLACIO' => $poblacio,
            'ID_PROVINCIA' => $provincia,
            'CENTRETREBALL' => $centretreball,
            'TELEFON' => $telefon,
            'EMAIL' => $email,
            'PASSWORD' => $pass
            );

        $notificador = $this->mlogin->insert_data_notificador($data);
       
        if ($notificador != 0){

            // notifica per pantalla 
            $time = now();
            $fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));     
            $date = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);

            $data['nomemisor'] = $nomemisor;
            $data['email'] = $email;
            $data['pass'] = $pass;
            $data['date'] = $date;



            // Configuració email
            $config['protocol'] = 'smtp';
            $config['smtp_host'] = '192.168.1.3';
            $config['smtp_port'] = '25';
            $config['wordwrap'] = TRUE;
            $config['charset'] = 'utf-8';
            $config['crlf'] = '\r\n';
            $config['newline'] = '\r\n';
            $config['mailtype'] = 'html'; 


            // enviament email -> notificador
            $msg = '<strong>Data de registre:</strong> '.$date.'<br /><br />';
            $msg .= '<p>Benvolgut/da '.$nomemisor.', moltes gràcies per registrar-te a la web de Targeta Groga.<br /><br />';
            $msg .= 'Aquest registre et permetrà, entre altres coses, que al iniciar sessió puguis notificar sense tornar a introduïr les dades de notificador.<br /><br />';
            $msg .= '<strong>Recorda, per properes notificacions, iniciar sessió amb les següents dades: </strong><br /><br />';
            $msg .= 'E-mail: '.$email.'<br /><br />';
            $msg .= 'Contrasenya: '.$pass.'<br /><br />';
            $msg .= 'Per qualsevol consulta relacionada amb qüestions de terapèutica pots contactar amb nosaltres al telèfon 93 489 41 05.<br /><br /></p>';
            $msg .= '<p>Atentament,<br />Targeta Groga<br />Centre de Farmacovigilància de Catalunya<br /></p>';

            $this->email->initialize($config);
            $this->email->from('webmaster@icf.uab.cat');
            $this->email->to($email);
            $this->email->subject("Registre usuari TargetaGroga");         
            $this->email->message($msg);
            if($this->email->send())
            {
            $data['title'] = 'Targeta Groga';
            $data['main_content'] = 'vRegistreSuccess';


            $sesion_data = array(
                'nom' => $nomemisor,
                'email' => $email
                    );

            $this->session->set_userdata($sesion_data);

            $this->load->view('vtemplate', $data); 


            }
            else
            {
                show_error($this->email->print_debugger());
            }           

        } else {


            $data['title'] = 'Targeta Groga';
            $data['main_content'] = 'verror';
            $data['error'] = log_message('error', 'Alguna variable no contenía valor.');
            $this->load->view('vtemplate', $data);
            die();
        }

            }
        }
    }

    // mètode per l'actualització de dades d'usaris registrats
    public function update_user() {

        $altraprofessio = '';
        $professio = $this->input->post('ID_PROFESSIO');

        if ($professio == 6){
            $altraprofessio = $this->input->post('ALTRA_PROFESSIO');
        }

        $id = $this->input->post('ID_NOTIFICADORWEB');
        $nomemisor = $this->input->post('NOMEMISOR');
        $cognomsemisor = $this->input->post('COGNOMSEMISOR');
        $adreca = $this->input->post('ADRECA');
        $poblacio = $this->input->post('POBLACIO');
        $provincia = intval($this->input->post('ID_PROVINCIA'));
        $centretreball = $this->input->post('CENTRETREBALL');
        $telefon = $this->input->post('TELEFON');
        $email = $this->input->post('EMAIL');
        $pass = $this->input->post('PASSWORD');        
        

        // Update taula DT_NOTIFICADORWEB
        $data = array(
            //'ID_NOTIFICADORWEB' => intval($id),
            'ID_PROFESSIO' => intval($professio),
            'ALTRA_PROFESSIO' => $altraprofessio,
            'NOMEMISOR' => $nomemisor,
            'COGNOMSEMISOR' => $cognomsemisor,
            'ADRECA' => $adreca,
            'POBLACIO' => $poblacio,
            'ID_PROVINCIA' => intval($provincia),
            'CENTRETREBALL' => $centretreball,
            'TELEFON' => $telefon
          //  'EMAIL' => $email,
          //  'PASSWORD' => $pass
            );

        $notificador = $this->mlogin->update_data_notificador($id,$data);

        if ($notificador != 0){

            // notifica per pantalla 

            $time = now();
            $fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));     
            $date = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);

            $data['nomemisor'] = $nomemisor;
            $data['email'] = $email;
            $data['pass'] = $pass;
            $data['date'] = $date;



            // Configuració email
            $config['protocol'] = 'smtp';
            $config['smtp_host'] = '192.168.1.3';
            $config['smtp_port'] = '25';
            $config['wordwrap'] = TRUE;
            $config['charset'] = 'utf-8';
            $config['crlf'] = '\r\n';
            $config['newline'] = '\r\n';
            $config['mailtype'] = 'html'; 


            // enviament email -> notificador
            $msg = '<strong>Data d\'actualització:</strong> '.$date.'<br /><br />';
            $msg .= '<p>Benvolgut/da '.$nomemisor.',<br /><br />';
            $msg .= 'Les teves dades han estat actualitzades correctament.<br /><br />';
            $msg .= 'Per qualsevol consulta relacionada amb qüestions de terapèutica pots contactar amb nosaltres al telèfon 93 489 41 05.<br /><br /></p>';
            $msg .= '<p>Atentament,<br />Targeta Groga<br />Centre de Farmacovigilància de Catalunya<br /></p>';

            $this->email->initialize($config);
            $this->email->from('webmaster@icf.uab.cat');
            $this->email->to($email);
            $this->email->subject("Registre usuari TargetaGroga");         
            $this->email->message($msg);
            if($this->email->send())
            {
            $data['title'] = 'Targeta Groga';
            $data['main_content'] = 'vActualitzacioSuccess';


            $sesion_data = array(
                'nom' => $nomemisor,
                'email' => $email
                    );

            $this->session->set_userdata($sesion_data);

            $this->load->view('vtemplate', $data); 


            }
            else
            {
                show_error($this->email->print_debugger());
            }           

        } else {


            $data['title'] = 'Targeta Groga';
            $data['main_content'] = 'verror';
            $data['error'] = log_message('error', 'Alguna variable no contenía valor.');
            $this->load->view('vtemplate', $data);
            die();
        }

    }

    // mètode per esborrar l'usuari de la Base de Dades
    public function delete_user() {
        $id = $this->input->get('val');

        $notificador = $this->mlogin->delete_notificador($id);

        if ($notificador){        
        echo('El registre nº '.$id.' ha estat esborrat de la nostra Base de Dades');
        } else{
            echo('El registre no existeix a la Base de Dades');
        }
    }    

    // redirect a la plana vRemember    
    public function remember() {
        $data['title'] = $this->lang->line('titol');
        $data['main_content'] = 'vRemember';

        $this->load->view('vtemplate', $data);
    }


    // mètode verificació CAPTCHA
    function captcha_check(){
        $expiration = time() -3600;
        $binds = array($this->input->post('captcha'),$this->input->ip_address(),$expiration);

        return $this->mcaptcha->captchaExist($binds);
    }

    // redirect a la plana vRegistreSuccess    
    public function notificacio(){

            $page['title'] = 'Targeta Groga';
            $page['main_content'] = 'vRegistreSuccess';

            $this->load->view('vtemplate', $page);
    }


    // mètode destrucció de sessió    
    public function destroy() {
        $this->mlogin->close();
        $page = array(
            'title' => $this->lang->line('titol'), 
            'main_content' => 'vIndex'
            );       
        $this->load->view('vtemplate', $page);    
    }

    // mètode recordatori contrasenya    
    public function rememberPass(){

        $email = $_POST['EMAILACCESS'];
        
        $result = $this->mlogin->getMail($email);


        if ($result == NULL){
            $data['variable'] = 'L\'adreça email facilitada no existeix a la Base de Dades';
            $data['title'] = $this->lang->line('titol');
            $data['main_content'] = 'vRemember';
            
            $this->load->view('vtemplate', $data);

        } else if($result!=NULL) { 

            foreach ($result as $key) {
                $email = $key->EMAIL;
                $pass = $key->PASSWORD;
            }

            // Configuració email
            $config['protocol'] = 'smtp';
            $config['smtp_host'] = '192.168.1.3';
            $config['smtp_port'] = '25';
            $config['wordwrap'] = TRUE;
            $config['charset'] = 'utf-8';
            $config['crlf'] = '\r\n';
            $config['newline'] = '\r\n';
            $config['mailtype'] = 'html';


            // enviament email -> notificador
            $msg = '<p>Benvolgut/da company/a<br /><br />';
            $msg .= 'Hem rebut una solicitut de recordatori de contrasenya per iniciar sessió a www.targetagroga.cat<br />';
            $msg .= 'En cas de no haber-la demanat, si us plau, ignora aquest missatge.<br /><br />';
            $msg .= 'En cas contrari, la contrasenya de validació per la direcció d\'email '.$email.' és <strong>'.$pass.'</strong><br /><br />';            
            $msg .= '<p>Atentament,<br />Targeta Groga<br />Centre de Farmacovigilància de Catalunya<br /></p>';

            $this->email->initialize($config);
            $this->email->from('webmaster@icf.uab.cat');
            $this->email->to($email);
            $this->email->subject("Recordatori contrasenya");         
            $this->email->message($msg);

            if($this->email->send()) {

                $data['title'] = $this->lang->line('titol');
                $data['main_content'] = 'vIndex';

                $this->load->view('vtemplate', $data);  

            } else{
                show_error($this->email->print_debugger());
            }
        } 
    }    
}

?>
