<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
 * @Package     CodeIgniter 2.1.3
 * @author      Carles Figuerola <cfiguerola0@uoc.edu> 
 * @copyright   Copyright (c) 2014, Carles Figuerola
 * @category    Controllers <02/04/2014>
 */
class Ctargeta extends CI_Controller {

    // càrrega de diferents languages i models
	public function __construct() {
		parent::__construct();
		$this->lang->load('general', 'catalan');
		$this->lang->load('form_validation', 'catalan');
		$this->load->model('mconsultas');
		$this->load->model('mlogin');		
		$this->load->model('mcaptcha');
	}

	// Presenta la plana principal de la Targeta Groga
	public function index() {

		$page = array('title' => $this->lang->line('titol'), 'main_content' => 'vIndex');		
		$this->load->view('vtemplate', $page);		
	}

	// redirect a la plana de login
	public function login() {
		$data['title'] = $this->lang->line('titol');
		$data['main_content'] = 'vLogin';
		$this->load->view('vtemplate', $data);

	}

	// Deriva l'usuari cap a: Nova notificació o Seguiment
	public function notificar() {

		$id = $this->input->get('id');
		$name = $this->input->post('boton');

		if ($name == 'notificacio' || $id == 'notificacio') {				
			$data['title'] = $this->lang->line('titol');
			$data['main_content'] = 'vNotificar';
			$this->load->view('vtemplate', $data);
		} else {
			$data['title'] = $this->lang->line('titol');
			$data['main_content'] = 'vIndex';
			$this->load->view('vtemplate', $data);
		}

	}


	// Carrega plana "formulari" o "seguiment"
	public function formulari() {

		$name = $this->input->post('boton');

		if ($name == 'notificacio') {

			if($this->session->userdata('id_notificadorweb')){
				$id_notificadorweb = $this->session->userdata('id_notificadorweb');
				$data = array (
					'ID_NOTIFICADORWEB' => $id_notificadorweb,        
					);

				$result = $this->mlogin->getDadesAccess($data);
				if($result!=NULL){

					$data['title'] = $this->lang->line('titol');
					$data['main_content'] = 'vformPacient';
					$data['dades'] = $this->mlogin->getDadesAccess($data);						

 					$this->load->view('vtemplate', $data);
				}	
			} else {
					$data['title'] = $this->lang->line('titol');
					$data['main_content'] = 'vformPacient';

 					$this->load->view('vtemplate', $data);

			}     
		} else {
			$data['title'] = $this->lang->line('titol');
			$data['main_content'] = 'vSeguiment';
			$this->load->view('vtemplate', $data);			
		}	

	}

	// Carrega plana de seguiment de notificació
	public function seguiment_noti(){

			$data['title'] = $this->lang->line('titol');
			$data['main_content'] = 'vSeguiment';
			$this->load->view('vtemplate', $data);

	}

	// Carrega plana de seguiment d'avís legal
	public function legal() {

		$page = array(
			'title' => 'Avís legal',
			'main_content' => 'vLegal'
			);

		$this->load->view('vtemplate', $page);		
	}

	// Carrega plana de privacitat
	public function privacitat() {


		$page = array(
			'title' => 'Politica de privadesa',
			'main_content' => 'vPrivadesa');

		$this->load->view('vtemplate', $page);		
	}

	// Carrega plana de contacte
	public function contactar() {
		// regla de validació CAPTCHA
		$this->form_validation->set_rules('captcha','Captcha','callback_captcha_check');
		$this->form_validation->set_error_delimiters('<span class="error font-red ">', '</span>');
		

		if ($this->form_validation->run('captcha') == false){ 

			$captcha = array(
			'word' => '',
			'img_path' => './captcha/',
			'img_url' => base_url().'captcha/',
			'font_path' => './fonts/DroidSans.ttf',
			'img_width' => 150,
			'img_height' => 30,
			'expiration' => 3600
			);
		

			/* 
				Paràmetres cambiats a captcha_helper.php (per -> size i color de la font)	
				
				$font_size  = 16;
				$text_color = imagecolorallocate ($im, 204, 153, 153);
			*/

			$cap = create_captcha($captcha);


			$captcha_info = array(
				'CAPTCHA_TIME' => $cap['time'],
				'IP_ADDRESS' => $this->input->ip_address(),
				'WORD' => $cap['word']
				);

			//print_r($captcha_info);

			$this->mcaptcha->insertCaptcha($captcha_info);

			$page = array(
				'title' => 'Formulari de contacte',
				'main_content' => 'vContacte',
				'cap' => $cap
				);

			$this->load->view('vtemplate',$page);	
		

		} else {
				$time = now();
				$fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));		
				$data_mail = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);

				$nom = $this->input->post('NOM_CONTACTE');
				$email = $this->input->post('EMAIL');
				$observacions = $this->input->post('OBS_CONTACTE');

				$data['title'] = 'Targeta Groga - Contacte';
				$data['main_content'] = 'vsuccessContacte';
				$data['nom'] = $nom;
				$data['data_mail'] = $data_mail;

		        // enviament email -> CONTACTE
				$msg = '<strong>Data d\'enviament:</strong> '.$data_mail.'<br /><br /><strong>Persona que fa la consulta:</strong> '.$nom.'<br /><strong>email de contacte:</strong> '.$email.'<br /><strong>Observacions:</strong> '.$observacions.'<br /><br />';

				$this->email->from($email);
				$this->email->to('slt@icf.uab.cat,cf@icf.uab.cat');
				$this->email->subject("Email rebut des de la web de Targeta Groga");			
				$this->email->message($msg);
				if($this->email->send())
				{
					$this->load->view('vtemplate', $data);
				}
				else
				{
					show_error($this->email->print_debugger());
				}

		}

	}

    // mètode verificació CAPTCHA
	function captcha_check(){
		$expiration = time() -3600;
		$binds = array($this->input->post('captcha'),$this->input->ip_address(),$expiration);

		return $this->mcaptcha->captchaExist($binds);
	}

	// Carrega plana de resposta de formulari
	public function notificacio(){

			$page['title'] = 'Targeta Groga';
			$page['main_content'] = 'vsuccess';

			$this->load->view('vtemplate', $page);
	}

	// Carrega plana de formulari de seguiment
	public function seguiment_data(){

			$page['title'] = 'Targeta Groga';
			$page['main_content'] = 'vSeguiment';

			$this->load->view('vtemplate', $page);
	}	

	// Carrega plana de resposta de notificació i envia email
	public function sendmail(){

			// notifica per pantalla
			$time = now();
			$fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));		
			$data_mail = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);

			$nom = $this->input->post('NOM_CONTACTE');
			$email = $this->input->post('EMAIL');
			$observacions = $this->input->post('OBS_CONTACTE');

			$data['title'] = 'Targeta Groga - Contacte';
			$data['main_content'] = 'vsuccessContacte';
			$data['nom'] = $nom;
			$data['data_mail'] = $data_mail;

	        // enviament email -> CONTACTE
			$msg = '<strong>Data d\'enviament:</strong> '.$data_mail.'<br /><br /><strong>Persona que fa la consulta:</strong> '.$nom.'<br /><strong>email de contacte:</strong> '.$email.'<br /><strong>Observacions:</strong> '.$observacions.'<br /><br />';

			$this->email->from($email);
			$this->email->to('slt@icf.uab.cat,cf@icf.uab.cat');
			$this->email->subject("Email rebut des de la web de Targeta Groga");			
			$this->email->message($msg);
			if($this->email->send())
			{
				$this->load->view('vtemplate', $data,true);
			}
			else
			{
				show_error($this->email->print_debugger());
			}

	}

	// FUNCIONS INTRODUCCIÓ DE SOSPITA (DADES, FARMACS I OBSERVACIONS)
	// Inserta dades de nova notificació
	public function insert_registres() { 

		// declaració de variables
		$codiss = $this->input->post('CODISS'); 
		$nfarms = intval($this->input->post('NFARMS')); 
		$nreacs = intval($this->input->post('NREACS'));  

		// obtencio de camps de notificacio 
		$nom = $this->input->post('NOMPACIENT');
		$cognoms = $this->input->post('COGNOMSPACIENT');
		$sexe = $this->input->post('ID_SEXE');
		$edat = intval($this->input->post('EDAT'));
		$unitatedat = $this->input->post('ID_UNITATEDAT');
		if ($unitatedat== 1){
			$unitatedat = 804;
		} elseif ($unitatedat== 2) {
			$unitatedat = 803;
		} elseif ($unitatedat== 3) {
			$unitatedat = 802;
		} elseif ($unitatedat== 4) {
			$unitatedat = 801;
		} else{
			$unitatedat = -1;
		}		

		$grupedat = $this->input->post('ID_GRUPEDAT');
		
		if ($grupedat == ''){ 
			$grupedat= '-1';
		}
		

		$pes = $this->input->post('PES');

		if (is_null($pes) || strlen(trim($pes)) == 0 ){
			$pes = 'NULL';
		}

		$nhc = $this->input->post('NHC');
		$rammotiva = $this->input->post('ID_RAMMOTIVA');

		$altraprofessio = '';


		$professio = $this->input->post('ID_PROFESSIO');		

	
		if ($professio == 6){
			$altraprofessio = $this->input->post('ALTRA_PROFESSIO');
		}


		$nomemisor = $this->input->post('NOMEMISOR');
		$cognomsemisor = $this->input->post('COGNOMSEMISOR');
		$adreca = $this->input->post('ADRECA');
		$poblacio = $this->input->post('POBLACIO');
		$provincia = intval($this->input->post('ID_PROVINCIA'));
		$centretreball = $this->input->post('CENTRETREBALL');
		$telefon = $this->input->post('TELEFON');
		$email = $this->input->post('EMAIL');


		//echo('Professio: '.$professio.',Altra professio: '.$altraprofessio.',Nom emisor: '.$nomemisor.',Cognoms emisor: '.$cognomsemisor.',Adreça: '.$adreca.',Població: '.$poblacio.',Província: '.$provincia.',Centre treball: '.$centretreball.',Telèfon: '.$telefon.',Email: '.$email);

		$observacions = nl2br($this->input->post('OBSERVACIONS'));		
		$procedencia = $this->input->post('PROCEDENCIA_SOSPITA');

		$time = now();
		$fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));		
		$data = '%Y-%m-%d %H:%i:%s';

		$data_noti_insert = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);		



		// INSERT taula DT_SOSPITA
		$data = array(
			'DATA' => $data_noti_insert,
			'ID_PROCEDENCIASOSPITA' => $procedencia,						
			'ID_PRIORITAT' => -1,
			'NOMPACIENT' => $nom,
			'COGNOMSPACIENT' => $cognoms,
			'ID_SEXE' => intval($sexe),
			'EDAT' => intval($edat),
			'ID_UNITATEDAT' => intval($unitatedat),
			'ID_GRUPEDAT' => intval($grupedat),
			'PES' => floatval($pes),
			'ID_RAMMOTIVA'=> intval($rammotiva),
			'NHC' => $nhc,
			'ID_PROFESSIO' => intval($professio),
			'ALTRA_PROFESSIO' => $altraprofessio,
			'ID_IDENTEMISOR' => -1,
			'NOMEMISOR' => $nomemisor,
			'COGNOMSEMISOR' => $cognomsemisor,
			'ADRECA' => $adreca,
			'POBLACIO' => $poblacio,
			'ID_PROVINCIA' => $provincia,
			'CENTRETREBALL' => $centretreball,
			'ID_SERVEIHOSP' => -1, 
			'TELEFON' => $telefon,
			'EMAIL' => $email,
			//'MESTARGETES' => $mestargetes,
			//'MESINFO' => $mesinfo,
			'OBSERVACIONS' => $observacions,
			'TEST' => 1,
			'CODISS' => $codiss
			);

		$sospita_ID = $this->mconsultas->insert_data_sospita($data);
		$this->mconsultas->update_data_sospita($sospita_ID);

		// INSERT taula DT_SOSPITA_ORIGINAL
		$data = array(
			'ID_SOSPITA' => $sospita_ID,
			'DATA' => $data_noti_insert,
			'NOMPACIENT' => $nom,
			'COGNOMSPACIENT' => $cognoms,
			'ID_SEXE' => intval($sexe),
			'EDAT' => intval($edat),
			'ID_UNITATEDAT' => intval($unitatedat),
			'ID_GRUPEDAT' => intval($grupedat),
			'PES' => floatval($pes),
			'ID_RAMMOTIVA'=> intval($rammotiva),
			'NHC' => $nhc,
			'ID_PROFESSIO' => intval($professio),
			'ALTRA_PROFESSIO' => $altraprofessio,
			'NOMEMISOR' => $nomemisor,
			'COGNOMSEMISOR' => $cognomsemisor,
			'ADRECA' => $adreca,
			'POBLACIO' => $poblacio,
			'ID_PROVINCIA' => $provincia,
			'CENTRETREBALL' => $centretreball,
			'TELEFON' => $telefon,
			'EMAIL' => $email,
			//'MESTARGETES' => $mestargetes,
			//'MESINFO' => $mesinfo,
			'OBSERVACIONS' => $observacions,
			'TEST' => 1
			);

		$this->mconsultas->insert_data_sospita_original($data);

		// Tractament de dades per presentar a la pàgina de resultats

		$sexe_out =  ($sexe == 1) ? $sexe = 'masculí' : $sexe = 'femení';

		$unitatedat_out = intval($unitatedat);
            
		if ($unitatedat== 1){
			$unitatedat = 804;
		} elseif ($unitatedat== 2) {
			$unitatedat = 803;
		} elseif ($unitatedat== 3) {
			$unitatedat = 802;
		} elseif ($unitatedat== 4) {
			$unitatedat = 801;
		} else{
			$unitatedat = -1;
		}            
        switch ($unitatedat_out) {
            case 804:
                $unitatedat_out =  "dies";
                break;
            case 803:
                $unitatedat_out =  "setmanes";
                break;
            case 802:
                $unitatedat_out =  "mesos";
                break;
            case 801:
                $unitatedat_out =  "anys";
                break;
            case -1:
                $unitatedat_out =  "desconegut";
                break;                
            default:
                $unitatedat_out =  "  -  ";
                break;                                                        
        }


		$grupedat_out = intval($grupedat);
            
        switch ($grupedat_out) {
            case 1:
                $grupedat_out =  "nadó (0-27 dies)";
                break;
            case 2:
                $grupedat_out =  "lactant (28 dies -23 messos)";
                break;
            case 3:
                $grupedat_out =  "nen (2-11 anys)";
                break;
            case 4:
                $grupedat_out =  "adolescent (12-17 anys)";
                break;
            case 5:
                $grupedat_out =  "adult (18-65 anys)";
                break;                                                        
            case 6:
                $grupedat_out =  "vell (més de 65 anys)";
                break;                
            default:
				$grupedat_out =  "  -  ";
        }

		$rammotiva_out =  intval($rammotiva);
        
        switch ($rammotiva_out) {
            case 1:
                $rammotiva_out =  "atenció a urgències d'hospital";
                break;
            case 2:
                $rammotiva_out =  "ingrés a l'hospital";
                break;
            case 3:
                $rammotiva_out =  "allargament de l'hospitalització";
                break;
            case 4:
                $rammotiva_out =  "atenció extrahospitalària";
                break;
            case 5:
                $rammotiva_out =  "cap de les anteriors o es desconeix";
                break;                                                        
            default:
				$rammotiva_out =  "  -  ";
        }	

		$professio_out =  intval($professio);
        
        switch ($professio_out) {
            case 1:
                $professio_out =  "metge";
                break;
            case 2:
                $professio_out =  "farmacèutic";
                break;
            case 3:
                $professio_out =  "ats/dui";
                break;
            case 6:
                $professio_out =  $altraprofessio;
                break;
            default:
				$professio_out =  "  -  ";
        }

		$provincia_out =  $provincia;
        switch ($provincia_out) {
            case 1:
                $provincia_out =  "Barcelona";
                break;
            case 2:
                $provincia_out =  "Girona";
                break;
            case 3:
                $provincia_out =  "Lleida";
                break;
            case 4:
                $provincia_out =  "Tarragona";
                break;
            default:
				$provincia_out =  "  -  ";
        }

		$dades_notificador_out = "<strong>ID de la notificació:&nbsp;&nbsp;&nbsp;</strong>".$sospita_ID."<br />";
		$dades_notificador_out .= "<strong>Codi de seguretat:&nbsp;&nbsp;&nbsp;</strong>".$codiss."<br />";
		$dades_notificador_out .= "<strong>Email del notificador:&nbsp;&nbsp;&nbsp;</strong>".$email."<br />";	

		$pacient_out = "<strong>Nom: </strong>".$nom." ".$cognoms."<br />";
		$pacient_out .= "<strong>Sexe: </strong>".$sexe_out."<br /><strong>Pes: </strong>".floatval($pes)." kg<br /><strong>Edat: </strong>".intval($edat)." ".$unitatedat_out."<br /><strong>Grup d'edat: </strong>".$grupedat_out."<br/>";
		$pacient_out .= "<strong>NHC: </strong>".$nhc."<br /><strong>La reacció adversa ha requerit: </strong>".$rammotiva_out."<br />";						
		
		$notificador_out = "<strong>Professional que notifica: </strong>".$professio_out."<br /><strong>Nom: </strong>".$nomemisor." ".$cognomsemisor."<br /><strong>Centre treball: </strong>".$centretreball."<br/>";
		$notificador_out .= "<strong>Adreça: </strong>".$adreca."<br /><strong>Població: </strong>".$poblacio."<br /><strong>Província: </strong>".$provincia_out."<br />";
		$notificador_out .= "<strong>Telèfon: </strong>".$telefon."<br/>";																		
		$notificador_out .= "<strong>E-mail: </strong>".$email."<br/>";		


		$obs =  ($observacions) ? $obs = $observacions : $obs = '  -  ';

		$obs_out = $obs;				


		// Obtencio de camps de farmac(s)

        $farms_out = "";
		$nfarms = $_POST['NFARMS'];
		$i=1;$tractats=0;
		set_time_limit(10);

		while (($tractats < $nfarms)&&($i<1000)) {
			if (isset($_POST['FARM_FARMAC_'.$i])) {
				$farmac = $this->input->post('FARM_FARMAC_'.$i); 
				$dosi = $this->input->post('FARM_DOSI_'.$i);
				$viaadmin = $this->input->post('FARM_ID_VIAADMIN_'.$i);
				$datainici = $this->input->post('FARM_DATAINICI_'.$i);
				$datafinal = $this->input->post('FARM_DATAFINAL_'.$i);
				$prescripcio = $this->input->post('FARM_PRESCRIPCIO_'.$i);

				// INSERT taula DT_SOSPITAFARMAC 
				$data = array(
					'ID_SOSPITA' => $sospita_ID,						
					'FARMAC' => $farmac,
					'DOSI' => $dosi,
					'ID_VIAADMIN' => $viaadmin,
					'DATAINICI' => $datainici,
					'DATAFINAL' => $datafinal,
					'PRESCRIPCIO' => $prescripcio
					);
				$this->mconsultas->insert_data_sospita_farmac($data);

				$tractats++;

				$viaadmin_out = $viaadmin;

		        switch ($viaadmin_out) {
		            case 1:
		                $viaadmin_out =  "auricular";
		                break;
		            case 2:
		                $viaadmin_out =  "bucal";
		                break;
		            case 3:
		                $viaadmin_out =  "intradèrmica";
		                break;
		            case 4:
		                $viaadmin_out =  "intramuscular";
		                break;
		            case 5:
		                $viaadmin_out =  "intravenosa bol.";
		                break;                                                        
		            case 6:
						$viaadmin_out =  "intravenosa got.";
						break;
		            case 7:
		                $viaadmin_out =  "intravenosa n.e.";
		                break;
		            case 8:
		                $viaadmin_out =  "nasal";
		                break;
		            case 9:
		                $viaadmin_out =  "oftàlmica";
		                break;
		            case 10:
		                $viaadmin_out =  "oral";
		                break;
		            case 11:
		                $viaadmin_out =  "parenteral";
		                break;                                                        
		            case 12:
						$viaadmin_out =  "rectal";
						break;
		            case 13:
		                $viaadmin_out =  "respiratoria";
		                break;
		            case 14:
		                $viaadmin_out =  "subcutània";
		                break;
		            case 15:
		                $viaadmin_out =  "sublingual";
		                break;
		            case 16:
		                $viaadmin_out =  "tòpica";
		                break;
		            case 17:
		                $viaadmin_out =  "transdèrmica";
		                break;                                                        
		            case 18:
		                $viaadmin_out =  "transplacentaria";
		                break;
		            case 19:
		                $viaadmin_out =  "vaginal";
		                break;
		            case 20:
		                $viaadmin_out =  "desconeguda";
		                break;
		            case 30:
		                $viaadmin_out =  "<span style='color:red;'>consulteu observacions</span>";
		                break;
		            default:
						$viaadmin_out =  "  -  ";

		        }

				$farms_out = "<strong>Fàrmac - ".$tractats.": </strong>".$farmac.", <strong>dosi: </strong>".$dosi.", <strong>via admin.: </strong>".$viaadmin_out.", <strong>inici: </strong>".$datainici.", <strong>final: </strong>".$datafinal.", <strong>motiu: </strong>".$prescripcio."<br/>";				
			}
			$i++;
		}
		
		//obtencio de camps de reaccio(ns) 

        $reacs_out = ""; 
		$nreacs = $_POST['NREACS'];
		$i=1;$tractats=0;
		set_time_limit(10);
		while (($tractats < $nreacs)&&($i<1000)) {
			if (isset($_POST['REAC_REACCIO_'.$i])) {
				$reaccio = $this->input->post('REAC_REACCIO_'.$i); 
				$datainici = $this->input->post('REAC_DATAINICI_'.$i);
				$datafinal = $this->input->post('REAC_DATAFINAL_'.$i);
				$desen = $this->input->post('REAC_ID_DESEN_'.$i);


				if ($desen == ''){
					$desen = -1;
				}

				// INSERT taula DT_SOSPITAREACCIOADVERSA
				$data = array(
					'ID_SOSPITA' => $sospita_ID,					
					'REACCIO' => $reaccio, 
					'DATAINICI' => $datainici, 
					'DATAFINAL' => $datafinal, 
					'ID_DESEN' => $desen 					
					);
				$this->mconsultas->insert_data_sospita_reaccio($data);	
				
				$tractats++;				

				$desen_out = $desen;

				switch ($desen_out) {
					case 1:
						$desen_out =  "recuperat";
						break;
					case 2:
						$desen_out =  "en recuperació";
						break;
					case 3:
						$desen_out =  "no recuperat";
						break;
					case 4:
						$desen_out =  "recuperat amb seqüeles";
						break;
					case 5:
						$desen_out =  "mortal";
						break;
					case 6:
						$desen_out =  "desconegut";
						break;
					default:
						$desen_out = " - ";
						break;
				}    

				$reacs_out = "<strong>Reacció - ".$tractats.": </strong>".$reaccio.", <strong>inici: </strong>".$datainici.", <strong>final: </strong>".$datafinal.", <strong>desenllaç: </strong>".$desen_out."<br/>";
			}
			$i++;	
		}
	
		/* Resultat de l'INSERT:
					ok: Es presenta plana success amb les dades necesàries per fer seguiment ID_sospita, codiss i email. 
				 Error: Es presenta plana d'error	
		*/

		if ($sospita_ID != 0){

			// notifica per pantalla			
			$data['data'] = $data_noti_insert;
			$data['id'] = $sospita_ID;
			$data['codiss'] = $codiss;
			$data['email'] = $email;
			$data['pacient_out'] = $pacient_out;
			$data['farms_out'] = $farms_out;
			$data['reacs_out'] = $reacs_out;
			$data['obs_out'] = $obs_out;
			$data['dades_notificador_out'] = $dades_notificador_out;
			$data['notificador_out'] = $notificador_out;
			$data['tipus'] = 'de notificació';


			// Configuració email
			$config['protocol'] = 'smtp';
	        $config['smtp_host'] = '192.168.1.3';
	        $config['smtp_port'] = '25';
	        $config['wordwrap'] = TRUE;
			$config['charset'] = 'utf-8';
			$config['crlf'] = '\r\n';
	        $config['newline'] = '\r\n';
	        $config['mailtype'] = 'html'; 


	        // enviament email -> notificador
			$msg = '<strong>Data de notificació:</strong> '.$data_noti_insert.'<br /><br />';
			$msg .= '<p>Benvolgut/da company/a<br /><br />Moltes gràcies per participar en el Programa de Targeta Groga amb la notificació d\'un cas de sospita de reacció adversa. ';
			$msg .= 'La notificació d\'efectes indesitjats, per bé que ja siguin coneguts, permet conèixer millor el perfil de seguretat del fàrmac.<br /><br />';
			$msg .= 'Per mitjà d\'aquest missatge et confirmem que hem rebut les dades de notificació de la reacció adversa al Centre de Farmacovigilància i que correspon amb';
			$msg .= ' el nostre número de referència <strong>'.$sospita_ID.' </strong></p>';
			$msg .= '<strong>Els següents camps seran obligatoris en el cas de realitzar un seguiment d\'aquesta notificació de reacció adversa</strong><br /><br />';
			$msg .= '<strong>ID de la notificació:</strong> '.$sospita_ID.'<br /><strong>Codi seguretat:</strong> '.$codiss.'<br /><strong>Email:</strong> '.$email.'<br /><br />';
			$msg .= '<p>Si necessitem més informació sobre algun aspecte del cas per tal de facilitar la seva avaluació, ens posarem en contacte amb tu.<br />';
			$msg .= 'Per qualsevol consulta relacionada amb qüestions de terapèutica pots contactar amb nosaltres al telèfon 93 489 41 05.<br /><br /></p>';
			$msg .= '<p>Atentament,<br />Targeta Groga<br />Centre de Farmacovigilància de Catalunya<br /></p>';

        	$this->email->initialize($config);
			$this->email->from('webmaster@icf.uab.cat');
			$this->email->to($email);
			$this->email->subject("Nova notificació online");			
			$this->email->message($msg);
			if($this->email->send())
			{

				$this->session->set_flashdata('dades', $data);
				redirect('ctargeta/notificacio');	


			}
			else
			{
				show_error($this->email->print_debugger());
			}			

		} else {


			$data['title'] = 'Targeta Groga';
			$data['main_content'] = 'verror';
			$data['error'] = log_message('error', 'Alguna variable no contenía valor.');
			$this->load->view('vtemplate', $data);
			die();
		}
	}

	// FUNCIONS INTRODUCCIÓ SEGUIMENTS
	// Formulari principal per accedir-hi a seguiment

	public function seguiment(){

			$time = now();
			$fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));		
			$data = '%Y-%m-%d %H:%i:%s';

			$data_noti_insert = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);	

			$sospita_ID = $this->input->post('ID_SOSPORIGINAL');
			$codiss = $this->input->post('ID_CODISS');
			$email = $this->input->post('EMAIL');



			$data = array (
				'ID_SOSPITA' => $sospita_ID,		
				'CODISS' => $codiss,			
				'EMAIL' => $email,
				);



			$result = $this->mconsultas->select_data_seguiment($data);


			if ($result!=NULL){

				$data['title'] = 'Targeta Groga';
				$data['main_content'] = 'vSeguimentFarmacs';
				$data['dades'] = $this->mconsultas->select_data_seguiment($data);

				$data['pacient'] = $this->mconsultas->get_dades_pacient_notificador($sospita_ID);		
				$data['farmacs'] = $this->mconsultas->select_farmacs($data);
				$data['reaccions'] = $this->mconsultas->select_reaccions($data);
				$data['date'] = $data_noti_insert; 

				$this->load->view('vtemplate', $data);
	

			} else {

				$data['main_content'] = 'vSeguiment';
				$data['id'] = $sospita_ID;
				$data['codiss'] = $codiss;
				$data['email'] = $email;

				$this->session->set_flashdata('dades', $data);
				redirect('ctargeta/seguiment_data');	

			}
	}

	// Formulari introducció dades seguiment
	// INSERT a la taula DT_SOSPITA
	public function insert_seguiment(){

		$email = $this->input->post('EMAIL');
		$nfarms = intval($this->input->post('NFARMS')); 
		$nreacs = intval($this->input->post('NREACS')); 		
			
		$sospita_ref_ID = $this->input->post('SOSPITA_REF');
		$codiss = $this->input->post('CODISS');

		$time = now();
		$fechaLocal = gmt_to_local($time, 'UP1', date('I', $time));		
		$data = '%Y-%m-%d %H:%i:%s';

		$data_noti_insert = mdate("%Y-%m-%d %H:%i:%s", $fechaLocal);	

		// INSERT taula DT_SOSPITA
		$procedencia = $this->input->post('PROCEDENCIA_SOSPITA');
		$observacions = $this->input->post('OBSERVACIONS');


		//comprovem si la sospita te assignat número de notificació
		$nnoti = $this->mconsultas->get_nnoti($sospita_ref_ID);
		
		//comprovem si la sospita te assignat número de notificador
		$notificador = $this->mconsultas->get_notificador($sospita_ref_ID);
		

		$registrada = NULL;
		
		if($nnoti!= NULL){
			$registrada = 1;
		} 

		// recuperem dades necessàries per inserir a DT_SOSPITA (seguiment)
		$result = $this->mconsultas->get_dades_pacient_notificador($sospita_ref_ID);

		// dades del Pacient
		$nompacient = $result[0]->NOMPACIENT;
		$cognomspacient = $result[0]->COGNOMSPACIENT;
		$sexe = $result[0]->ID_SEXE;
		$edat = $result[0]->EDAT;
		$unitatedat = $result[0]->ID_UNITATEDAT;
		$grupedat = $result[0]->ID_GRUPEDAT;
		$pes = $result[0]->PES;
		$rammotiva = $result[0]->ID_RAMMOTIVA;
		$nhc = $result[0]->NHC;

		// dades del notificador
		$professio = $result[0]->ID_PROFESSIO;
		$altre_professio = $result[0]->ALTRA_PROFESSIO;
		$identemisor = $result[0]->ID_IDENTEMISOR;
		$nomemisor = $result[0]->NOMEMISOR;
		$cognomsemisor = $result[0]->COGNOMSEMISOR;
		$inicialemisor = $result[0]->INICIALSEMISOR;
		$adreca = $result[0]->ADRECA;
		$poblacio = $result[0]->POBLACIO;		
		$provincia = $result[0]->ID_PROVINCIA;
		$centretreball = $result[0]->CENTRETREBALL;
		$serveihosp = $result[0]->ID_SERVEIHOSP;
		$telefon = $result[0]->TELEFON ;

		$data = array(
			'DATA' => $data_noti_insert,
			'NNOTI' => $nnoti,
			'ID_PROCEDENCIASOSPITA' => intval($procedencia),
			'SEGUIMENT' => 1,
			'SEGUIMENT_ID_SOSPITA' => $sospita_ref_ID,
			'REGISTRADA' => $registrada,
			'ID_PRIORITAT' => -1,
			'NOMPACIENT' => $nompacient,
			'COGNOMSPACIENT' => $cognomspacient,
			'ID_SEXE' => $sexe,
			'EDAT' =>  $edat,
			'ID_UNITATEDAT' => $unitatedat,
			'ID_GRUPEDAT' => $grupedat,
			'PES' => $pes,
			'ID_RAMMOTIVA' => $rammotiva,
			'NHC' => $nhc,
			'ID_ASSIGNANOTIFICADOR' => $notificador,
			'ID_PROFESSIO' => intval($professio),	
			'ALTRA_PROFESSIO' => $altre_professio,		
			'ID_IDENTEMISOR' => $identemisor,
			'NOMEMISOR' => $nomemisor,
			'COGNOMSEMISOR' => $cognomsemisor,
			'INICIALSEMISOR' => $inicialemisor,
			'ADRECA' => $adreca,
			'POBLACIO' => $poblacio,			
			'ID_PROVINCIA' => $provincia,
			'CENTRETREBALL' => $centretreball,
			'ID_SERVEIHOSP' => $serveihosp,
			'TELEFON' => $telefon,
			'EMAIL' => $email,			
			'OBSERVACIONS' => $observacions,
			'TEST' => 1,
			'CODISS' => $codiss
			);

		$sospita_rel_ID = $this->mconsultas->insert_data_sospita($data);


		// Tractament de dades per presentar a la pàgina de resultats

		$sexe_out =  ($sexe == 1) ? $sexe = 'masculí' : $sexe = 'masculí';

		$unitatedat_out = intval($unitatedat);
            
		if ($unitatedat== 1){
			$unitatedat = 804;
		} elseif ($unitatedat== 2) {
			$unitatedat = 803;
		} elseif ($unitatedat== 3) {
			$unitatedat = 802;
		} elseif ($unitatedat== 4) {
			$unitatedat = 801;
		} else{
			$unitatedat = -1;
		}            
        switch ($unitatedat_out) {
            case 804:
                $unitatedat_out =  "dies";
                break;
            case 803:
                $unitatedat_out =  "setmanes";
                break;
            case 802:
                $unitatedat_out =  "mesos";
                break;
            case 801:
                $unitatedat_out =  "anys";
                break;
            case -1:
                $unitatedat_out =  "desconegut";
                break;                
            default:
                $unitatedat_out =  "  -  ";
                break;                                                        
        }


		$grupedat_out = intval($grupedat);
            
        switch ($grupedat_out) {
            case 1:
                $grupedat_out =  "nadó (0-27 dies)";
                break;
            case 2:
                $grupedat_out =  "lactant (28 dies -23 messos)";
                break;
            case 3:
                $grupedat_out =  "nen (2-11 anys)";
                break;
            case 4:
                $grupedat_out =  "adolescent (12-17 anys)";
                break;
            case 5:
                $grupedat_out =  "adult (18-65 anys)";
                break;                                                        
            case 6:
                $grupedat_out =  "vell (més de 65 anys)";
                break;                
            default:
				$grupedat_out =  "  -  ";
        }

		$rammotiva_out =  intval($rammotiva);
        
        switch ($rammotiva_out) {
            case 1:
                $rammotiva_out =  "atenció a urgències d'hospital";
                break;
            case 2:
                $rammotiva_out =  "ingrés a l'hospital";
                break;
            case 3:
                $rammotiva_out =  "allargament de l'hospitalització";
                break;
            case 4:
                $rammotiva_out =  "atenció extrahospitalària";
                break;
            case 5:
                $rammotiva_out =  "cap de les anteriors o es desconeix";
                break;                                                        
            default:
				$rammotiva_out =  "  -  ";
        }	

		$professio_out =  intval($professio);
        
        switch ($professio_out) {
            case 1:
                $professio_out =  "metge";
                break;
            case 2:
                $professio_out =  "farmacèutic";
                break;
            case 3:
                $professio_out =  "ats/dui";
                break;
            case 6:
                $professio_out =  $altre_professio;
                break;
            default:
				$professio_out =  "  -  ";
        }

		$provincia_out =  $provincia;
        switch ($provincia_out) {
            case 1:
                $provincia_out =  "Barcelona";
                break;
            case 2:
                $provincia_out =  "Girona";
                break;
            case 3:
                $provincia_out =  "Lleida";
                break;
            case 4:
                $provincia_out =  "Tarragona";
                break;
            default:
				$provincia_out =  "  -  ";
        }

		$dades_notificador_out = "<strong>ID de la notificació:&nbsp;&nbsp;&nbsp;</strong>".$sospita_ref_ID."<br />";
		$dades_notificador_out .= "<strong>Codi de seguretat:&nbsp;&nbsp;&nbsp;</strong>".$codiss."<br />";
		$dades_notificador_out .= "<strong>Email del notificador:&nbsp;&nbsp;&nbsp;</strong>".$email."<br />";		

		$pacient_out = "<strong>Nom: </strong>".$nompacient." ".$cognomspacient."<br />";
		$pacient_out .= "<strong>Sexe: </strong>".$sexe_out."<br /><strong>Pes: </strong>".floatval($pes)." kg<br /><strong>Edat: </strong>".intval($edat)." ".$unitatedat_out."<br /><strong>Grup d'edat: </strong>".$grupedat_out."<br/>";
		$pacient_out .= "<strong>NHC: </strong>".$nhc."<br /><strong>La reacció adversa ha requerit: </strong>".$rammotiva_out."<br />";						
		
		$notificador_out = "<strong>Professional que notifica: </strong>".$professio_out."<br /><strong>Nom: </strong>".$nomemisor." ".$cognomsemisor."<br /><strong>Centre treball: </strong>".$centretreball."<br/>";
		$notificador_out .= "<strong>Adreça: </strong>".$adreca."<br /><strong>Població: </strong>".$poblacio."<br /><strong>Província: </strong>".$provincia_out."<br />";
		$notificador_out .= "<strong>Telèfon: </strong>".$telefon."<br/>";																		
		$notificador_out .= "<strong>E-mail: </strong>".$email."<br/>";		


		$obs =  ($observacions) ? $obs = $observacions : $obs = '';

		$obs_out = $obs;				

	
		// obtencio de camps de farmac(s) i generacio consulta(es) d'accio

        $farms_out = "";
		$nfarms = $_POST['NFARMS'];
		$i=1;$tractats=0;
		set_time_limit(10);

		while (($tractats < $nfarms)&&($i<1000)) {
			$farmac = $this->input->post('FARM_FARMAC_'.$i);
			if (isset($_POST['FARM_FARMAC_'.$i])&&$farmac != null) {
				$farmac = $this->input->post('FARM_FARMAC_'.$i);				 
				$dosi = $this->input->post('FARM_DOSI_'.$i);
				$viaadmin = $this->input->post('FARM_ID_VIAADMIN_'.$i);
				$datainici = $this->input->post('FARM_DATAINICI_'.$i);
				$datafinal = $this->input->post('FARM_DATAFINAL_'.$i);
				$prescripcio = $this->input->post('FARM_PRESCRIPCIO_'.$i);

				// INSERT taula DT_SOSPITAFARMAC 
				$data = array(
					'ID_SOSPITA' => $sospita_rel_ID,						
					'FARMAC' => $farmac,
					'DOSI' => $dosi,
					'ID_VIAADMIN' => $viaadmin,
					'DATAINICI' => $datainici,
					'DATAFINAL' => $datafinal,
					'PRESCRIPCIO' => $prescripcio
					);
				$this->mconsultas->insert_data_sospita_farmac($data);
				$tractats++;

				$viaadmin_out = $viaadmin;

		        switch ($viaadmin_out) {
		            case 1:
		                $viaadmin_out =  "auricular";
		                break;
		            case 2:
		                $viaadmin_out =  "bucal";
		                break;
		            case 3:
		                $viaadmin_out =  "intradèrmica";
		                break;
		            case 4:
		                $viaadmin_out =  "intramuscular";
		                break;
		            case 5:
		                $viaadmin_out =  "intravenosa bol.";
		                break;                                                        
		            case 6:
						$viaadmin_out =  "intravenosa got.";
						break;
		            case 7:
		                $viaadmin_out =  "intravenosa n.e.";
		                break;
		            case 8:
		                $viaadmin_out =  "nasal";
		                break;
		            case 9:
		                $viaadmin_out =  "oftàlmica";
		                break;
		            case 10:
		                $viaadmin_out =  "oral";
		                break;
		            case 11:
		                $viaadmin_out =  "parenteral";
		                break;                                                        
		            case 12:
						$viaadmin_out =  "rectal";
						break;
		            case 13:
		                $viaadmin_out =  "respiratoria";
		                break;
		            case 14:
		                $viaadmin_out =  "subcutània";
		                break;
		            case 15:
		                $viaadmin_out =  "sublingual";
		                break;
		            case 16:
		                $viaadmin_out =  "tòpica";
		                break;
		            case 17:
		                $viaadmin_out =  "transdèrmica";
		                break;                                                        
		            case 18:
		                $viaadmin_out =  "transplacentaria";
		                break;
		            case 19:
		                $viaadmin_out =  "vaginal";
		                break;
		            case 20:
		                $viaadmin_out =  "desconeguda";
		                break;
		            case 30:  
		                $viaadmin_out =  "<span style='color:red;'>consulteu observacions</span>";
		                break;
		            default:
						$viaadmin_out =  null;	
				}
				if ($farms_out != ""){
					$farms_out .= "<br />";
				}
				$farms_out .= "<strong>Fàrmac - ".$tractats.": </strong>".$farmac.", <strong>dosi: </strong>".$dosi.", <strong>via admin.: </strong>".$viaadmin_out.", <strong>inici: </strong>".$datainici.", <strong>final: </strong>".$datafinal.", <strong>motiu: </strong>".$prescripcio;												
								
			}
			$i++;
		}

		//obtencio de camps de reaccio(ns) i generacio consulta(es) d'accio

        $reacs_out = ""; 
		$nreacs = $_POST['NREACS'];
		$i=1;$tractats=0;
		set_time_limit(10);
		while (($tractats < $nreacs)&&($i<1000)) {
			$reaccio = $this->input->post('REAC_REACCIO_'.$i);
			if (isset($_POST['REAC_REACCIO_'.$i])&&$reaccio != null) {
				$reaccio = $this->input->post('REAC_REACCIO_'.$i); 
				$datainici = $this->input->post('REAC_DATAINICI_'.$i);
				$datafinal = $this->input->post('REAC_DATAFINAL_'.$i);
				$desen = $this->input->post('REAC_ID_DESEN_'.$i);

				if ($desen == ''){
					$desen = -1;
				}
				
				// INSERT taula DT_SOSPITAREACCIOADVERSA
				$data = array(
					'ID_SOSPITA' => $sospita_rel_ID,					
					'REACCIO' => $reaccio, 
					'DATAINICI' => $datainici, 
					'DATAFINAL' => $datafinal, 
					'ID_DESEN' => $desen 					
					);
				
				$this->mconsultas->insert_data_sospita_reaccio($data);
				$tractats++;

				$desen_out = $desen;

				switch ($desen_out) {
					case 1:
						$desen_out =  "recuperat";
						break;
					case 2:
						$desen_out =  "en recuperació";
						break;
					case 3:
						$desen_out =  "no recuperat";
						break;
					case 4:
						$desen_out =  "recuperat amb seqüeles";
						break;
					case 5:
						$desen_out =  "mortal";
						break;
					case 6:
						$desen_out =  "desconegut";
						break;
					default:
						$desen_out = " - ";
						break;
				}  

				if ($reacs_out != ""){
					$reacs_out .= "<br/>";
				}
				$reacs_out .= "<strong>Reacció - ".$tractats.": </strong>".$reaccio.", <strong>inici: </strong>".$datainici.", <strong>final: </strong>".$datafinal.", <strong>desenllaç: </strong>".$desen_out;
								
			}
			$i++;	
		}

		// Presentació plana de resultats

		if ($sospita_rel_ID != 0){

			// notifica per pantalla	
			$data['title'] = 'Targeta Groga';
			$data['main_content'] = 'vsuccessSeguiment';
			$data['data'] = $data_noti_insert;
			$data['id'] = $sospita_ref_ID;
			$data['codiss'] = $codiss;
			$data['email'] = $email;
			$data['dades_notificador_out'] = $dades_notificador_out;			
			$data['pacient_out'] = $pacient_out;
			$data['farms_out'] = $farms_out;
			$data['reacs_out'] = $reacs_out;
			$data['obs_out'] = $obs_out;
			$data['notificador_out'] = $notificador_out;
			$data['tipus'] = 'de seguiment';			


	        // enviament email -> notificador
			$msg = '<strong>Data de notificació:</strong> '.$data_noti_insert.'<br /><br />';
			$msg .= '<p>Benvolgut/da company/a<br /><br />Moltes gràcies per participar en el Programa de Targeta Groga amb la notificació d\'un cas de sospita de reacció adversa. ';
			$msg .= 'La notificació d\'efectes indesitjats, per bé que ja siguin coneguts, permet conèixer millor el perfil de seguretat del fàrmac.<br /><br />';
			$msg .= 'Per mitjà d\'aquest missatge et confirmem que hem rebut les dades de seguiment de la reacció adversa al Centre de Farmacovigilància i que correspon amb ';
			$msg .= 'el nostre número de referència <strong>'.$sospita_ref_ID.' </strong></p>';
			$msg .= '<strong>Els següents camps seran obligatoris en el cas de realitzar un seguiment d\'aquesta notificació de reacció adversa</strong><br /><br />';
			$msg .= '<strong>ID de la notificació:</strong> '.$sospita_ref_ID.'<br /><strong>Codi de seguretat:</strong> '.$codiss.'<br /><strong>Email del notificador:</strong> '.$email.'<br /><br />';
			$msg .= '<p>Si necessitem més informació sobre algun aspecte del cas per tal de facilitar la seva avaluació, ens posarem en contacte amb tu.<br />';
			$msg .= 'Per qualsevol consulta relacionada amb qüestions de terapèutica pots contactar amb nosaltres al telèfon 93 489 41 05.<br /><br /></p>';
			$msg .= '<p>Atentament,<br />Targeta Groga<br />Centre de Farmacovigilància de Catalunya<br /></p>';
			$this->email->from('webmaster@icf.uab.cat');
			$this->email->to($email);
			$this->email->subject("Notificació de seguiment online - test");			
			$this->email->message($msg);
			if($this->email->send())
			{
	
				$this->session->set_flashdata('dades', $data);
				redirect('ctargeta/notificacio');				
			}
			else
			{
				show_error($this->email->print_debugger());
			}			

		} else {

			$data['title'] = 'Targeta Groga';
			$data['main_content'] = 'verror';
			$data['error'] = log_message('error', 'Alguna variable no contenía un valor.');
			$this->load->view('vtemplate', $data);
			die();
		}			
	}	
}

// http://escodeigniter.com/guia_usuario/